#ifndef I2C_H
#define I2C_H

#include <io.h>		// include I/O definitions (port names, pin names, etc)
#include <sig-avr.h>	// include "signal" names (interrupt names)
#include <progmem.h>

#define TWCR_CMD_MASK           0x0F
#define TWSR_STATUS_MASK        0xF8

#include "global.h"

void i2cInit(void);

void i2cSend(u08 deviceAddr, u08 length, u08 *data);
void i2cReceive(u08 deviceAddr, u08 length, u08* data);

void i2cSendAndReceive(u08 deviceAddr, 
		       u08 sendlength, u08 *senddata, 
		       u08 receivelength, u08 *receivedata);

#endif
