#ifndef LCD_H
#define LCD_H

#include <io.h>		// include I/O definitions (port names, pin names, etc)
#include <sig-avr.h>	// include "signal" names (interrupt names)
#include <progmem.h>

#include "timer.h"
#include "global.h"

#define LCD_DATA_PORT    PORTA
#define LCD_COMMAND_PORT PORTD

// LCD control lines
#define LCD_E 		7
#define LCD_RW 		4
#define LCD_RS 		6
#define LCD_BIAS 	5

// LCD constants
#define LCD_BUSY 	7
#define LCD_SET_C_ADDRESS 	6
#define LCD_SET_D_ADDRESS 	7
#define LCD_RESET  0x01
#define LCD_RETURN 0x02

void lcdInit(void);
void lcdCommandWrite(u08 data);
void lcdDataWrite(u08 data);
void lcdReset(void);
void lcdReturn(void);
void lcdCheckBusy(void);
void lcdSetContrast(u08 contrast);
void lcdCustomChars(u08 *lcd_char_map);

#endif
