#include "./misc.h"

void printString(u08* s) {
  u08 i=0;
  while (s[i] != 0 && i != 255) {
    rprintf("%c", s[i]);
    i++;
  }
}

void printsubString(u08* s, int numChars) {
  u08 i=0;
  while (s[i] != 0 && i != 255 && i < numChars) {
    rprintf("%c", s[i]);
    i++;
  }
}

u08 stringLen(u08* s) {
   u08 i=0;
  while (s[i] != 0 && i <= 255) {
    i++;
  }
  return i;
}

// Takes a string of numChars length and null terminates it
void fixString(u08* s, int numChars) {
  u08 i = numChars - 1;
  while (s[i] == 0x20 && i <= 255) {
    s[i] = 0; 
    i--;
  }
}

// Nice function to print the time.  Rather straightforward.
void printTime(unsigned short hours, unsigned short minutes, unsigned short seconds)
{
  unsigned short printhours;
  unsigned short am;
  am = 1;
  printhours = hours;
  if (hours == 0) {
    printhours = 12;
  }
  else if (hours == 12) {
    am = 0;
  }	
  else if (hours > 12) {
    printhours = hours - 12;
    am = 0;
  }
  if (printhours < 10) rprintf(" ");
  rprintf("%d:", printhours);
  if (minutes < 10) rprintf("0");
  rprintf("%d:", minutes);
  if (seconds < 10) rprintf("0");
  rprintf("%d", seconds);
  if (am) rprintf("am");
  else rprintf("pm");
}	

// Nice function to print the time.  Rather straightforward.
void printDate(unsigned short date, unsigned short month, unsigned short year)
{
  if (month < 10) rprintf(" ");
  rprintf("%d/", month);
  if (date < 10) rprintf("0");
  rprintf("%d/", date);
  if ((year+1980)%100 < 10) rprintf("0");
  rprintf("%d", (year+1980)%100);
}

u08 not_leap(u08 year) {
  u16 actual;
  actual = 1980 + (u16)year;
  if (!(actual%100))
    return (u08)(actual%400);
  else
    return (u08)(actual%4);
}
      
void memorycpy(u08* to, u08* from, size_t numBytes){
  size_t i = 0;
  while (i < numBytes) {
    to[i] = from[i];
    i++;
  }
}

